/**
 * after processing library
 *
 */
import processing.serial.*;
import controlP5.*;
PImage bg; //sfondo

ControlP5 cp5;
Serial myPort;  // The serial port

int sliderValue = 100;
int bo = 10; //int che fra vuole e non so a che servono

Button hallinsert;
Button calibration; 

String reading = "";
int nums; 


void setup() {
  size(1024, 768);
  smooth();
  noStroke();

  bg = loadImage("moonwalk3.jpg");

  cp5 = new ControlP5(this);

  hallinsert = cp5.addButton("insert ")  //review this part (button must change with data)
    .setValue(0)
    .setPosition(462, 200)
     .setImages(loadImage("opened.png"),loadImage("opened.png"), loadImage("closed.png"))
    .setSize(100, 50)
    ;

  //bottone immagine sfondo
  calibration = cp5.addButton("calibra")
    .setValue(1)
    .setPosition(462, 100)
    .setImages(loadImage("Arrow-Left.png"), loadImage("Arrow-Right.png"), loadImage("Refresh.png"))
    .updateSize();


  cp5.addSlider("sliderValue")
    .setPosition(472, 500)
    .setRange(0, 255)
    .setSize(200, 50) 
    ;

  // try to connect to serial port
  String serialList[] = Serial.list();
  if (serialList.length > 0) {
    myPort = new Serial(this, Serial.list()[0], 115200); //change the 0 to a 1 or 2 etc. to match your port
  } else {
    println("No found Serial Port");
  }
}     

void draw() {
  background(bg);
  // background(myColorBackground);
  fill(sliderValue);

}

public void serialEvent(Serial serialPort) {
  //put the incoming data into a String - 
  //the '\n' is our end delimiter indicating the end of a complete packet
  String reading = serialPort.readStringUntil('\n');
  //make sure our data isn't empty before continuing
  if (reading != null) {
    //trim whitespace and formatting characters (like carriage return)
    reading = trim(reading);
    println(reading);
    
    if (reading.equals("1")) {
      println("inserito!");
      // Inserisci qua come ti segnala se è inserito
    } else if (reading.equals("0")){
      println("disinserito!");
      // Inserisci qua come ti segnala se non è inserito
    }
  }
}

public void calibra(int theValue) {
  myPort.write("c");  //premi e vai in modalità calibrazione
  println("c");
  calibration.hide();  // si può premere una sola volta poi sparisce
}

public void sliderValue(int value) {
  myPort.write(Integer.toString(value)); //commenta quando usi senza arduino
  println(value);
}















/* myKnobB = cp5.addKnob("knobValue")
 .setRange(0,255)
 .setValue(220)
 .setPosition(100,210)
 .setRadius(50)
 .setNumberOfTickMarks(10)
 .setTickMarkLength(4)
 .snapToTickMarks(true)
 .setColorForeground(color(255))
 .setColorBackground(color(0, 160, 100))
 .setColorActive(color(255,255,0))
 .setDragDirection(Knob.HORIZONTAL)
 ;
 */
